=== debian/changelog ===
vulkan (1.0.39.0+dfsg1-1) unstable; urgency=medium

  [ Andreas Boll ]
  * New upstream release.
  * Refresh patches.
  * control: Add libxrandr-dev to build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 26 Jan 2017 17:43:33 +0200

vulkan (1.0.37.0+dfsg1-1) unstable; urgency=medium

  [ Andreas Boll ]
  * Ship vulkan_intel.h via libvulkan-dev (Imported from Mesa source
    package).

  [ Timo Aaltonen ]
  * New upstream release.
  * Refresh patches.
  * demos-add-install-rule.diff, layers-install-to-cmake-install-libdir.diff,
    loader-add-install-rule.diff: Dropped, upstream.
  * control: Add libwayland-dev to build-depends.
  * disable-mir.diff: Don't try to build with Mir support, which Debian
    doesn't have.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 23 Dec 2016 08:39:12 +0200

vulkan (1.0.26.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * patches: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 20 Sep 2016 08:30:52 +0300
